#ifndef PROGRESSIVEEVALUATION_H_
#define PROGRESSIVEEVALUATION_H_
#include "../Individu/Genotype.h"

double minFitness=0;

template <class EOT>
class progressiveEvaluation : public eoEvalFunc<EOT>
{
public:
		/**
		 * constructeur par defaut vide
		 */
  progressiveEvaluation()
 
  {
   
  }
  int goalFluent(CPTFluentArray goal,CPTFluentArray state){
  	if(state.nb==0)return 0;
  	int nbGoal=0;
  	for(int i=goal.nb-1; i>=0;--i){
  		for(int j=state.nb-1;j>=0;--j){
  			if(cptGetIndexFromFluent(goal.elems[i])==cptGetIndexFromFluent(state.elems[j])){
  				nbGoal++;
  				break;
  			}
  		}
  	}
  	return nbGoal;
  }
  
   void operator()(EOT & _eo)
  {
    
    if (_eo.invalid())
      {
      	cptResetSearch();
      	 CPTSolutionPlan plan;
      	 
      	 CPTFluentArray goal = cptGetGoal();
      	 double fit=(double)global.getPenalite()*(global.stationMax*10*(global.stationMax+1)+goal.nb);
      	 cptResetSearch();
      	 size_t totalBacktrack=0;
      	 double makespan=0;
      	 double GareUtile=0;
      	 double time,ptime,stime;
      	 int test=1;
      	 //int fast=0;
      	int nb_Fluent=0;
      	if( _eo.getGenome().size()<global.stationMax){
      	 for (size_t i = 0; i < _eo.getGenome().size(); i++) {
      	 	if(i==0)nb_Fluent=_eo.get(i).getGene().size();
      	 	else nb_Fluent=_eo.get(i).getGene().size();
      	 	char *tmp[nb_Fluent];
      	 	size_t pos=0;
      	 	for(size_t k=i;k<=i;k++){
				for(size_t j=0;j<_eo.get(k).getGene().size();j++){
					tmp[pos]=new (nothrow) char[100];
					tmp[pos]= cptGetFluentName(cptGetFluentFromIndex(_eo.get(k).getGene()[(int)j]));
					pos++;
				}
      	 	}
			
		    CPTFluentArray station = cptGetFluentArrayFromNames(tmp, nb_Fluent);
		    global.setMaxb((CPTmaxbks()<100?10000:CPTmaxbks()));
		    cptSetMaxBacktracks(global.getMaxb());
		     plan = cptSolveNext(station); 
		     if (plan) {
		    	makespan+= cptGetMakespan(plan);
		    	if(cptGetMakespan(plan))++GareUtile;
		    	_eo.get(i).setbk(cptGetBacktracks(plan));
		    	totalBacktrack+=cptGetBacktracks(plan);
		    	time+=cptGetSearchTime(plan);
		    	/*CPTFluentArray state= cptState();
		      	if(goalFluent(goal,state)==goal.nb){
		       		plan = cptSolveNext(goal);
		       		if(plan){
		       			_eo.setbackGoal(cptGetBacktracks(plan));
		    			totalBacktrack+=cptGetBacktracks(plan);
		       			time+=cptGetSearchTime(plan);
		       			fast=1;
		       			break;
		       		}
		       	}*/
		    	
		    	if(fit<0){
		    		_eo.setPlan(plan);
		    	}
		   		
		    }
		    else{
		    	test=0; 
		       	_eo.setBreakStation(i+1);
		       	CPTFluentArray state= cptState();
		    	//fit=global.getPenalite()*(global.stationMax*(10*(goal.nb-goalFluent(goal,state))+11)- GareUtile);
		    	fit=global.getPenalite()*(global.stationMax*10*(global.stationMax- GareUtile+1)+(goal.nb-goalFluent(goal,state)));
		    	_eo.setPlan(plan);
		    	break;
		     }
		  }
		  
		   if(test) {
		   		
		   		_eo.setBreakStation(_eo.getGenome().size());
			   	global.setMaxb((7*CPTmaxbks()>100?7*CPTmaxbks():10000));
			   	cptSetMaxBacktracks(global.getMaxb());
			   	//cout << _eo <<"\n";
				plan = cptSolveNext(goal);
			     if (plan) {
			    	makespan+= cptGetMakespan(plan);
			    	_eo.setbackGoal(cptGetBacktracks(plan));
			    	totalBacktrack+=cptGetBacktracks(plan);
			    	time+=cptGetSearchTime(plan);
			    	//fit=global.getPenalite();
			   
			    }
			    else{
			    	test=0; 
			    	_eo.setBreakStation(_eo.getGenome().size());
			    	_eo.setPlan(plan);
			       	CPTFluentArray state= cptState();
			    	fit=global.getPenalite()*(global.stationMax*(10*(goal.nb-goalFluent(goal,state))+11)- GareUtile);//CPTinformationDAE();
			    }
		   }
		   
		  
		  if(test) {
		   	unsigned cb=0;
		  	_eo.setBreakStation(_eo.getGenome().size());
		  	global.setMaxb(CPTmaxbks());
		    cptSetMaxBacktracks(global.getMaxb());
		  	plan = cptCompressSolution(false,false);
		  	
		  	if(!plan)
		  	{
		  		
		  		cptSetMaxBacktracks(global.getMaxb());
		  		plan = cptCompressSolution(false,true);
		  		if(!plan)
		  		{
		  			
		  			cptSetMaxBacktracks(global.getMaxb());
		  			plan = cptCompressSolution(true,true);
		  		}
		  	}
		  	
		  	if(plan){
		  		makespan+=cptGetMakespan(plan);
		  		time=cptGetTotalTime(plan);
		  		ptime=cptGetPreprocessingTime(plan);
		  		stime=cptGetSearchTime(plan);
		  		_eo.setDplan(cptGetMakespan(plan));
		  		fit=cptGetMakespan(plan)+(_eo.getGenome().size()+1-GareUtile)/cptGetMakespan(plan)+totalBacktrack/10000;;
		  		_eo.setPlan(plan);
		  		cb+=cptGetBacktracks(plan);
		  		_eo.setcompressbk(cb);
		  		totalBacktrack+=cb;
		  		_eo.setBacktrack(totalBacktrack);
		  		_eo.setTime(time);
		  		_eo.setStime(stime);
		  		if(minFitness==0 || fit < minFitness){
		  			//fclose(result);
		  			minFitness=fit;
		  			result=fopen(resultFile.c_str(),"wb");
		  			_eo.printPlanVal(result);
		  			fclose(result);
		  		}
		  	}
		  	else 
			{		  		
				fit=global.getPenalite()*(global.getMaxSize()+1);
		  	
		  		_eo.setPlan(plan);
		    	
			}
			
		  }
		  
		 
		  _eo.setTime(time);
		  _eo.setStime(stime);
		  
      	}
      	else fit=fit*2;  
		
		
	_eo.fitness(fit);
      }
      
  }
  
};
#endif /*PROGRESSIVEEVALUATION_H_*/
